define(function(require,exports,module){
	var $ = require("jquery");
	var commonApp = {
		checkApi:{
			jsApiList:["getUkey","openWeb","openAppPage","appShare","varietyDate"],
			jsPageCode:[101,102,103,104,105,106,107],
			fun:"commonApp.jsApiResult"
		},
		resultApi:{
			jsApiList:{
				getUkey:true,openWeb:true,openAppPage:true,appShare:true,varietyDate:true
			},
			jsPageCode:{
				page101:true,page102:true,page103:true,page104:true,page105:true,page106:true,page107:true
			}
		},
		init:function(){
			//检测jsApi接口
			this.TakingApp("checkJsApi",this.checkApi);
		},
		jsApiResult:function(json){
			var self = this;
			for(var key1 in self.resultApi){
				for(var key2 in self.resultApi[key1]){
					self.resultApi[key1][key2] = json[key1][key2];
				}
			}
		},
		MatchFun:function(meth){
			return this.resultApi.jsApiList[meth];
		},
		MatchPage:function(pid){
			return this.resultApi.jsPageCode["page"+pid];
		},
		TakingApp:function(meth,json,fun){
			var self = this;
			var jsonStr = JSON.stringify(json);
			if(self.MatchFun(meth)){
				if(meth=="openAppPage"){
					if(json.pid!=undefined&&json.pid!=null&&self.MatchPage(json.pid)){
						//location.href=decodeURI("gw://"+meth+"?"+jsonStr);
						//location.href="gw://"+meth+"?"+jsonStr;
						var tmpurl = "gw://"+meth+"?"+jsonStr;
						self.addIframe(tmpurl);
					}else{
						if(fun!=null&&fun!=undefined&&$.isFunction(fun)){
							fun();
						}
					}
				}else{
					//location.href=decodeURI("gw://"+meth+"?"+jsonStr);
					//location.href="gw://"+meth+"?"+jsonStr;
					var tmpurl = "gw://"+meth+"?"+jsonStr;
					self.addIframe(tmpurl);
				}
			}else{
				if(fun!=null&&fun!=undefined&&$.isFunction(fun)){
					fun();
				}
			}
		},
		OpenPage:function(url,type,params){
			url = url.toLowerCase();
			if(type*1==2){
				if(url.indexOf("gw://")<0){
					url = "gw://"+url;
				}
				if(url.indexOf("openweb")>=0){
					this.TakingApp("openWeb",params);
				}else if(url.indexOf("openapppage")>=0){
					this.TakingApp("openAppPage",params);
				}else if(url.indexOf("appshare")>=0){
					this.TakingApp("appShare",params);
				}else if(url.indexOf("varietydate")>=0){
					this.TakingApp("varietyDate",params);
				}
			}else if(type==1){				
				location.href=url;
			}
		},
		//创建iframe
		addIframe:function(url){
			if($("#hide_iframe").length>0){
				$("#hide_iframe").attr("src",url);
			}else{
				var iframe = $("<iframe>").css("display","none").attr("id","hide_iframe");
				$("body").append(iframe);$("#hide_iframe").attr("src",url);
			}
		}
	}
	module.exports=commonApp;
})

